<?xml version="1.0" encoding="UTF-8" ?>
<taglib xmlns="http://java.sun.com/xml/ns/j2ee"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://java.sun.com/xml/ns/j2ee
  http://java.sun.com/xml/ns/j2ee/web-jsptaglibrary_2_0.xsd"
  version="2.0">
  
  <tlib-version>1.0</tlib-version>
  <short-name>csajsp-taglib-adv</short-name>
  <uri>http://coreservlets.com/csajsp-taglib-adv</uri>
  
  <tag>
    <description>
      Converts special HTML characters such as less than 
      and greater than signs to their corresponding HTML  
      character entities such as &lt; and &gt;.
    </description>
    <name>filterhtml</name>
    <tag-class>coreservlets.tags.HtmlFilterTag</tag-class>
    <body-content>scriptless</body-content>
  </tag>
  
  <tag>
    <description>
      Loops specified number of times.
    </description>
    <name>for</name>
    <tag-class>coreservlets.tags.ForTag</tag-class>
    <body-content>scriptless</body-content>
    <attribute>
      <description>
        Number of times to repeat body.
      </description>
      <name>count</name>
      <required>true</required>
      <rtexprvalue>true</rtexprvalue>
    </attribute>
  </tag>

  <tag>
    <description>
      Given an array of arrays, puts values into a table
    </description>
    <name>makeTable</name>
    <tag-class>coreservlets.tags.MakeTableTag</tag-class>
    <body-content>scriptless</body-content>
    <attribute>
      <description>
        An array of arrays. The top-level arrays
        represents the rows, the sub-arrays represent
        the column entries. 
      </description>
      <name>rowItems</name>
      <required>true</required>
      <rtexprvalue>true</rtexprvalue>
    </attribute>
    <attribute>
      <description>
        Style sheet class name for table header. 
      </description>
      <name>headerClass</name>
      <required>false</required>
    </attribute>
    <attribute>
      <description>
        Style sheet class name for table body. 
      </description>
      <name>bodyClass</name>
      <required>false</required>
    </attribute>
  </tag>

  <tag>
    <description>
      Loops down each element in an array
    </description>
    <name>forEach</name>
    <tag-class>coreservlets.tags.ForEachTag</tag-class>
    <body-content>scriptless</body-content>
    <attribute>
      <description>
        The array of elements.
      </description>
      <name>items</name>
      <required>true</required>
      <rtexprvalue>true</rtexprvalue>
    </attribute>
    <attribute>
      <description>
        The name of the scoped variable to which 
        each entry is assigned.
      </description>
      <name>var</name>
      <required>true</required>
    </attribute>
  </tag>
  
  <tag>
    <description>If tag</description>
    <name>if</name>
    <tag-class>coreservlets.tags.IfTag</tag-class>
    <body-content>scriptless</body-content>
    <attribute>
      <description>Condition of the if</description>
      <name>test</name>
      <required>true</required>
      <rtexprvalue>true</rtexprvalue>
    </attribute>
  </tag>
  
  <tag>
    <description>Then tag (goes with If tag)</description>
    <name>then</name>
    <tag-class>coreservlets.tags.ThenTag</tag-class>
    <body-content>scriptless</body-content>
  </tag>
  
  <tag>
    <description>Else tag (goes with If tag)</description>
    <name>else</name>
    <tag-class>coreservlets.tags.ElseTag</tag-class>
    <body-content>scriptless</body-content>
  </tag>
  
  <tag>
    <description>Conditionally outputs debug info</description>
    <name>debug</name>
    <tag-class>coreservlets.tags.DebugTag</tag-class>
    <body-content>scriptless</body-content>
  </tag>
  
  <function>
    <name>info</name>
    <function-class>coreservlets.jsp.Util</function-class>
    <function-signature>
      java.lang.String 
      information(javax.servlet.http.HttpServletRequest)
    </function-signature>
  </function>
</taglib>
